#include "Camera.h"

#include "Body.h"

/**
 * @brief Convert a given 2D screen position to a 3D position in view space.
 */
glm::vec3 Camera::ScreenToTrackball( glm::vec2 screenPos, glm::vec2 screenSize ) {
    auto x = (screenPos.x-(screenSize.x/2.f)) / (screenSize.x/2.f);
    auto y = ((screenSize.y/2.f)-screenPos.y) / (screenSize.y/2.f);
    auto z = 1 - x*x - y*y;
    glm::vec3 trackballPos;
    if (z < 0)
        trackballPos = glm::vec3( x/sqrtf(x*x+y*y), y/sqrtf(x*x+y*y), 0 );
    else
        trackballPos = glm::vec3( x, y, sqrtf(z) );
    return trackballPos;
}
